﻿using Dapper;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Web.Services;

namespace CrudWebService
{
    /// <summary>
    /// Summary description for FuncionariosService
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
    // [System.Web.Script.Services.ScriptService]
    public class FuncionariosService : System.Web.Services.WebService
    {
        [WebMethod]
        public int Inserir(Funcionario ofunci)
        {
            using (IDbConnection db = new SqlConnection(ConfigurationManager.ConnectionStrings["ConexaoSqlServer"].ConnectionString))
            {
                if (db.State == ConnectionState.Closed)
                {
                    db.Open();
                }                
                 
                DynamicParameters p = new DynamicParameters();
                p.Add("@FuncionarioID", dbType: DbType.Int32, direction: ParameterDirection.Output);
                p.AddDynamicParams(new { Nome = ofunci.Nome, Email = ofunci.Email, Endereco = ofunci.Endereco, Telefone = ofunci.Telefone, Cargo = ofunci.Cargo, ImagemUrl = ofunci.ImagemUrl });
                int resultado = db.Execute("sp_Funcionarios_Inserir", p, commandType: CommandType.StoredProcedure);

                if (resultado!=0)
                    return p.Get<int>("@FuncionarioID");

                return 0;
            }
        }

        [WebMethod]
        public bool Update(Funcionario ofunci)
        {
            using (IDbConnection db = new SqlConnection(ConfigurationManager.ConnectionStrings["ConexaoSqlServer"].ConnectionString))
            {
                if (db.State == ConnectionState.Closed)
                {
                    db.Open();
                }
                int resultado = db.Execute("sp_Funcionarios_Atualizar", new { FuncionarioID = ofunci.FuncionarioID, Nome = ofunci.Nome, Email = ofunci.Email, Endereco = ofunci.Endereco, Telefone = ofunci.Telefone, Cargo = ofunci.Cargo, ImagemUrl = ofunci.ImagemUrl }, commandType: CommandType.StoredProcedure);
                return resultado != 0;
            }
        }

        [WebMethod]
        public List<Funcionario> GetAll()
        {
            using (IDbConnection db = new SqlConnection(ConfigurationManager.ConnectionStrings["ConexaoSqlServer"].ConnectionString))
            {
                if (db.State == ConnectionState.Closed)
                {
                    db.Open();
                }
                return db.Query<Funcionario>("Select * from Funcionarios", commandType: CommandType.Text).ToList();
              
            }
        }

        [WebMethod]
        public bool Delete(int funciID)
        {
            using (IDbConnection db = new SqlConnection(ConfigurationManager.ConnectionStrings["ConexaoSqlServer"].ConnectionString))
            {
                if (db.State == ConnectionState.Closed)
                {
                    db.Open();
                }
                int resultado = db.Execute("delete from Funcionarios where FuncionarioID= @FuncionarioID", new { FuncionarioID = funciID }, commandType: CommandType.Text);
                return resultado != 0;
            }
        }
    }
}
